# OctopathBossRandomizer
Boss Randomizer for Octopath Traveler (Swtich and Steam)

See [mastermind1919's](https://github.com/mastermind1919/OctopathBossRandomizer/releases) releases for the full Steam version.

### About
Tired of fighting the bosses in the same order over and over? Wondered what it would be like to fight Galdera instead of the Orge Eagle? 
Than this is the option for you. The Boss randomizer changes the story boss encounters with a few configurable options. 

### Requirements
Requires [Visual Studio Redistributable 2019](https://support.microsoft.com/en-us/help/2977003/the-latest-supported-visual-c-downloads) and the libraries Zlib and OpenSSL.

### Usage
Head over to the releases section and download the latest version of the randomizer. Extract its contents somewhere, and run the executable inside.  
Find the pak dir of your Octopath Traveler folder, usually located under
```
(Steam)          C:\Program Files (x86)\Steam\Steamapps\Common\OCTOPATH TRAVELER\Octopath_Traveler\Content\Paks
(Switch SD card) \...\romfs\Kingship\Contents\Paks
```
Pick the options you want, and click randomize. The program will randomize the bosses, and place a patch pak file and a spoiler log in a subdir
named `<release>_seed_<seed###>`, e.g. `switch_seed_42`. For Steam, copy the file `RandomizeBosses_P.pak` to the games `pak` folder previously selected. For Switch, copy the folder `romfs` to the appropriate location on your SD card (e.g. if using Atmosphere, copy to `\...\atmosphere\contents\<titleID>`).

Don't forget to check out [MarvinXLII's](https://github.com/MarvinXLII/OctopathTravelerJobRandomizer) randomizer 
while you're at it! It should be compatable for both Steam and Switch releases!

### Features

The majority of features should work in this fork. Features crossed out are not compatible for the time being.

- Mix Chapter 2-4 Bosses: Allows the randomizer to randomize betwen chapter 2 - 4 boss pools, and with included options
- Mix Chapter 1-4 Bosses: Same as above, but with chapter 1 bosses as well
- Randomize Shrine Bosses: Randomizes the Advance Job Shrine Bosses among themselves
- Include Shrine Bosses: Include the Shrine Bosses with the chapter 4 boss pool randomization
- Randomize Gate Bosses: Randomizes the Gate of Finis Bosses among themselves
- Include Gate Bosses: Include the Gate of Finis Bosses with the chapter 4 boss pool randomization
- Include Galdera: Include both phases of Galdera in the chapter 4 boss pool randomization
- Allow Duplicates: Allows for bosses show up multiple times
- Full Random: As the name suggests, each boss has an equal chance of showing up in any particular encounter
- ~~Win Condition: Choose between having the credits roll upon completion of the main PC story, or of the Gate of Finis.~~
- ~~Solo Traveler Randomizer: Forces any boss past Chapter 1 to be fought solo using a random traveler. It is highly recommended that you get all characters before going past chapter 1. Both phases of Galdera are still fought using the whole party.~~
- Force Boss Tier: Forces a user specified amount of bosses in a pool to stay on that tier. For example, you can force 4 Chapter 1 bosses in the chapter 1 areas regardless of any other randomizer options.
- Force PC: Either forces a random or user specified PC to be the only one that shows up on the new game screen. This PC will always have a chapter 1 boss.

### Future Plans

- Include Side story bosses
- Enemy Randomizer

## Known Issues
